/*
 * ToRegExpKleene.cpp
 *
 *  Created on: 25. 3. 2019
 *	  Author: Tomas Pecka
 */

#include "ToRegExpKleene.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace convert {

auto ToRegExpKleeneDFA = registration::AbstractRegister < ToRegExpKleene, regexp::UnboundedRegExp < >, const automaton::DFA < > & > ( ToRegExpKleene::convert, "automaton" ).setDocumentation (
"Performs conversion.\n\
\n\
@param automaton finite automaton to convert\n\
@return unbounded regular expression equivalent to the original automaton" );

auto ToRegExpKleeneNFA = registration::AbstractRegister < ToRegExpKleene, regexp::UnboundedRegExp < >, const automaton::NFA < > & > ( ToRegExpKleene::convert, "automaton" ).setDocumentation (
"Performs conversion.\n\
\n\
@param automaton finite automaton to convert\n\
@return unbounded regular expression equivalent to the original automaton" );

auto ToRegExpKleeneENFA = registration::AbstractRegister < ToRegExpKleene, regexp::UnboundedRegExp < >, const automaton::EpsilonNFA < > & > ( ToRegExpKleene::convert, "automaton" ).setDocumentation (
"Performs conversion.\n\
\n\
@param automaton finite automaton to convert\n\
@return unbounded regular expression equivalent to the original automaton" );

auto ToRegExpKleeneMISNFA = registration::AbstractRegister < ToRegExpKleene, regexp::UnboundedRegExp < >, const automaton::MultiInitialStateNFA < > & > ( ToRegExpKleene::convert, "automaton" ).setDocumentation (
"Performs conversion.\n\
\n\
@param automaton finite automaton to convert\n\
@return unbounded regular expression equivalent to the original automaton" );

auto ToRegExpKleeneMISENFA = registration::AbstractRegister < ToRegExpKleene, regexp::UnboundedRegExp < >, const automaton::MultiInitialStateEpsilonNFA < > & > ( ToRegExpKleene::convert, "automaton" ).setDocumentation (
"Performs conversion.\n\
\n\
@param automaton finite automaton to convert\n\
@return unbounded regular expression equivalent to the original automaton" );

} /* namespace convert */

} /* namespace automaton */
