/*
 * EpsilonRemoverIncoming.cpp
 *
 *  Created on: 24. 11. 2014
 *	  Author: Jan Travnicek
 */

#include "EpsilonRemoverIncoming.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto EpsilonRemoverIncomingDFA = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::DFA < >, const automaton::DFA < > & > ( EpsilonRemoverIncoming::remove, "fsm" ).setDocumentation (
"Removes epsilon transitions from an automaton.\n\
\n\
@param fsm automaton to remove epsilon transitions from\n\
@return an automaton equivalent to @p fsm but without epsilon transitions" );

auto EpsilonRemoverIncomingMultiInitialStateNFA = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::MultiInitialStateNFA < > , const automaton::MultiInitialStateNFA < > & > ( EpsilonRemoverIncoming::remove, "fsm" ).setDocumentation (
"Removes epsilon transitions from an automaton.\n\
\n\
@param fsm automaton to remove epsilon transitions from\n\
@return an automaton equivalent to @p fsm but without epsilon transitions" );

auto EpsilonRemoverIncomingNFA = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::NFA < > , const automaton::NFA < > & > ( EpsilonRemoverIncoming::remove, "fsm" ).setDocumentation (
"Removes epsilon transitions from an automaton.\n\
\n\
@param fsm automaton to remove epsilon transitions from\n\
@return an automaton equivalent to @p fsm but without epsilon transitions" );

auto EpsilonRemoverIncomingEpsilonNFA = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::NFA < > , const automaton::EpsilonNFA < > & > ( EpsilonRemoverIncoming::remove, "fsm" ).setDocumentation (
"Removes epsilon transitions from an automaton.\n\
\n\
@param fsm automaton to remove epsilon transitions from\n\
@return an automaton equivalent to @p fsm but without epsilon transitions" );

} /* namespace simplify */

} /* namespace automaton */
