/*
 * Compaction.cpp
 *
 *  Created on: 2. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "Compaction.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

auto CompactionCompactNFA = registration::AbstractRegister < Compaction, automaton::CompactNFA < >, const automaton::CompactNFA < > & > ( Compaction::convert, "automaton" ).setDocumentation (
"Compaction of a finite automaton.\n\
\n\
@param automaton automaton to compact\n\
@return compact nondeterministic FA equivalent to @p automaton" );

auto CompactionDFA = registration::AbstractRegister < Compaction, automaton::CompactNFA < >, const automaton::DFA < > & > ( Compaction::convert, "automaton" ).setDocumentation (
"Compaction of a finite automaton.\n\
\n\
@param automaton automaton to compact\n\
@return compact nondeterministic FA equivalent to @p automaton" );

auto CompactionNFA = registration::AbstractRegister < Compaction, automaton::CompactNFA < >, const automaton::NFA < > & > ( Compaction::convert, "automaton" ).setDocumentation (
"Compaction of a finite automaton.\n\
\n\
@param automaton automaton to compact\n\
@return compact nondeterministic FA equivalent to @p automaton" );

} /* namespace transform */

} /* namespace automaton */
