/*
 * ToRegExp.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExp.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace convert {

auto ToRegExpRightRG = registration::AbstractRegister < ToRegExp, regexp::UnboundedRegExp < >, const grammar::RightRG < > & > ( ToRegExp::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression.\n\
\n\
@param grammar the regular grammar to convert\n\
@return regexp describing language generated by @p grammar." );

auto ToRegExpLeftRG = registration::AbstractRegister < ToRegExp, regexp::UnboundedRegExp < >, const grammar::LeftRG < > & > ( ToRegExp::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression.\n\
\n\
@param grammar the regular grammar to convert\n\
@return regexp describing language generated by @p grammar." );

} /* namespace convert */

} /* namespace grammar */
