/*
 * LinearString.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "LinearString.h"

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/SetRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < string::LinearString < > > ( );

static auto LinearStringFromString = registration::CastRegister < string::LinearString < char >, std::string > ( );

static auto LinearStringFromEpsilon = registration::CastRegister < string::LinearString < >, string::Epsilon < > > ( );

static auto LinearStringSet = registration::SetRegister < string::LinearString < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < string::LinearString < > > ( );

} /* namespace */
