/*
 * XmlTokensComposerAbstraction.hpp
 *
 *  Created on: 7. 10. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_
#define _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_

#include <abstraction/BinaryOperationAbstraction.hpp>
#include <sax/SaxComposeInterface.h>

namespace abstraction {

class XmlTokensComposerAbstraction : public BinaryOperationAbstraction < void, const ext::deque < sax::Token > &, const std::string & > {
public:
	virtual bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param2 = std::get < 0 > ( this->m_params );
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param1 = std::get < 1 > ( this->m_params );
		sax::SaxComposeInterface::composeFile ( abstraction::retrieveValue < const std::string & > ( param1.first, param1.second ), abstraction::retrieveValue < const ext::deque < sax::Token > & > ( param2.first, param2.second ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_ */
